unit MinimalMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, StdCtrls, Grids, SuggestEdit, Controls, LCLType;

type

  { TForm1 }

  TForm1 = class(TForm)
    ButtonNew: TButton;
    ButtonAdd: TButton;
    ButtonDelete: TButton;
    LabelDrink: TLabel;
    LabelPerson: TLabel;
    StringGridDrinks: TStringGrid;
    SuggestEditPerson: TSuggestEdit;
    SuggestEditDrink: TSuggestEdit;
    procedure ButtonAddClick(Sender: TObject);
    procedure ButtonDeleteClick(Sender: TObject);
    procedure ButtonNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure SuggestEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    AppPath: String;
    procedure Clear;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  AppPath := GetCurrentDir + PathDelim;

  if FileExists(AppPath + 'drinks.dat') then
    SuggestEditDrink.Items.LoadFromFile(AppPath + 'drinks.dat');

  if FileExists(AppPath + 'persons.dat') then
    SuggestEditPerson.Items.LoadFromFile(AppPath + 'persons.dat');

  if FileExists(AppPath + 'drinklist.csv') then
    StringGridDrinks.LoadFromCSVFile(AppPath + 'drinklist.csv');

  Clear;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  StringGridDrinks.SaveToCSVFile(AppPath + 'drinklist.csv');
  SuggestEditPerson.Items.SaveToFile(AppPath + 'persons.dat');
  SuggestEditDrink.Items.SaveToFile(AppPath + 'drinks.dat');
end;

procedure TForm1.SuggestEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN then
  begin
    Key := 0;
    SelectNext(Sender as TWinControl, True, True);
  end;
end;

procedure TForm1.Clear;
begin
  SuggestEditPerson.Text := '';
  SuggestEditDrink.Text := '';
  if SuggestEditPerson.HandleAllocated then
    SuggestEditPerson.SetFocus;
end;

procedure TForm1.ButtonNewClick(Sender: TObject);
begin
  Clear;
end;

procedure TForm1.ButtonAddClick(Sender: TObject);
begin
  StringGridDrinks.InsertRowWithValues(StringGridDrinks.RowCount,
    [SuggestEditPerson.Text, SuggestEditDrink.Text]);
  Clear;
end;

procedure TForm1.ButtonDeleteClick(Sender: TObject);
begin
  if StringGridDrinks.Row > 0 then
    StringGridDrinks.DeleteRow(StringGridDrinks.Row);
end;

end.

